*This do file uses the NBHS 2009 data to calculate module 4's share/core. 
*This share is then used to impute 2015's consumption for module 4

********************************************************************************
* Identify module shares 2015
********************************************************************************
*This do file calculates the consumption share of module 4 items. 
*It does to by calculating the share of module 4-equivalent items from the 
*2009 data. It compares the shares from 2009 of all other modules to calculate
*a scale factor to adjust for trends from 2009 to 2015. Since the 2009 data
*cannot be shared, this do file only shows the calculation of the 2015 shares
*The approach was analoguous for the 2009 data 

*The share calculations will have to be done manually in Excel

********************************************************************************
*Calculate module shares for comparison to 2009 and calculation of module 4
********************************************************************************
*Alternative
*Load data 
use "${gsdData}\1-CleanTemp\food.dta", clear
*Calculate shares of core for each item from 2009 dataset
bysort state ea hh mod_item: egen cons_hh = sum(cons_value)
*Calculate mean food shares of optional modules versus core 
collapse (mean) cons_hh [pweight=weight], by(mod_item)
export excel using "${gsdOutput}/shares.xls", sheet("Raw_F_2015") sheetreplace firstrow(var)

********************************************************************************
* Investigate individual changes of items from 2009 to 2015 as ratios of item/core
********************************************************************************
*Load 2015 data
use "${gsdData}\1-CleanTemp\food.dta", clear
*Merge core household aggregates
merge m:1 state ea hh using "${gsdData}/1-CleanTemp/hh_food_no4.dta", keepusing(food_opt0_hh_wk) nogen
*Calculate shares of core for each item from 2009 dataset
gen y = cons_value / food_opt0_hh_wk  
bysort itemid: egen share_of_core = mean(y)
collapse share_of_core [pweight=weight], by(itemid)
export excel using "${gsdOutput}/shares.xls", sheet("Raw_F_2015_Itemshares") sheetreplace firstrow(var)
