*This do file uses the NBHS 2009 data to calculate module 4's share/core. 
*This share is then used to impute 2015's consumption for module 4

********************************************************************************
* Identify module shares 2015
********************************************************************************
*This do file calculates the consumption share of module 4 items. 
*It does to by calculating the share of module 4-equivalent items from the 
*2009 data. It compares the shares from 2009 of all other modules to calculate
*a scale factor to adjust for trends from 2009 to 2015. Since the 2009 data
*cannot be shared, this do file only shows the calculation of the 2015 shares
*The approach was analoguous for the 2009 data 

*The share calculations will have to be done manually in Excel
********************************************************************************
* Calculate shares 
********************************************************************************

*Load data 
use "${gsdData}\1-CleanTemp\nonfood.dta", clear

*Calculate shares of core for each item from 2009 dataset
bysort state ea hh mod_item: egen cons_hh = sum(cons_value)

*Calculate mean nonfood shares of optional modules versus core 
collapse (mean) cons_hh [pweight=weight], by(mod_item)
export excel using "${gsdOutput}/shares.xls", sheet("Raw_NF_2015") sheetreplace firstrow(var)
