*This do-file cleans assets data and calculates the consumption flow of durables

*Check if filepaths have been established using init.do
if "${gsdData}"=="" {
	display as error "Please run init.do first."
	error 1
}
*Load data
use "${gsdData}/1-CleanInput/assets.dta", clear
*Check how many households consumed durables
bysort state ea hh: egen conssum = sum(own_pre) 
tab conssum

********************************************************************************
*Currencies: identification, labelling, and currency conversion
********************************************************************************
*Generate currency identifiers
gen curr = ""
*For currother_pre variable
replace curr = "Gift" if strpos(currother_pre, "A givety") | strpos(currother_pre, "A Givety")| strpos(currother_pre, "A givety") | strpos(currother_pre, "A givety") |  strpos(currother_pre, "form Ngos") |	strpos(currother_pre, "A givety from  orgnazition") | 	strpos(currother_pre, "AGivety") | 	strpos(currother_pre, "Agivety") | 	strpos(currother_pre, "Aid from NGO") | 	strpos(currother_pre, "Givety") | 	strpos(currother_pre, "Givety in the Hosptal") | 	strpos(currother_pre, "Free") | 	strpos(currother_pre, "Distributed  by  ngos") | 	strpos(currother_pre, "It was agivety") | 	strpos(currother_pre, "It was given as agivety") | 	strpos(currother_pre, "Its agivety") | 	strpos(currother_pre, "Its part of agivety") | 	strpos(currother_pre, "That one was agivety") | 	strpos(currother_pre, "Was agivety by Health Department") 					
replace curr = "SDD" if strpos(currother_pre, "Dinar") | strpos(currother_pre, "Dinar(last currency)") | 	strpos(currother_pre, "Dinare") | 	strpos(currother_pre, "Dinari") | 	strpos(currother_pre, "Dinnar") | 	strpos(currother_pre, "By that time it was sudunese courance..") | 	strpos(currother_pre, "SudaneseDinar") | 	strpos(currother_pre, "Sudanses Dinar") | 	 strpos(currother_pre, "SudaneseDinar") | 	strpos(currother_pre, "Sudanses Dinar") | 	strpos(currother_pre, "Sdanese dinar") | 	strpos(currother_pre, "Sudanese dinar") | 	strpos(currother_pre, "Sudanese dinary") | 	strpos(currother_pre, "Sudanese Denall") | 	strpos(currother_pre, "Sudanese Dinar") 																	
replace curr = "UGX" if	strpos(currother_pre, "250UGS") | strpos(currother_pre, "50000shillings") | 	strpos(currother_pre, "60 Ugsnda shls") | 	strpos(currother_pre, "U,G,S") | 	strpos(currother_pre, "UGS") | 	strpos(currother_pre, "Ug sihillings") | 	strpos(currother_pre, "Ugand Shillings") | 	strpos(currother_pre, "Uganda Shellings") | 	strpos(currother_pre, "Uganda Shilling") | 	strpos(currother_pre, "Uganda Shillings") | 	strpos(currother_pre, "Uganda Shls") | 	strpos(currother_pre, "Uganda currency") | 	strpos(currother_pre, "Uganda llings") | 	strpos(currother_pre, "Uganda shilling") | 	strpos(currother_pre, "Uganda shillings") | 	strpos(currother_pre, "Uganda sillings") | 	strpos(currother_pre, "Ugandan shilling") | 	strpos(currother_pre, "Ugandan shillings") | 	strpos(currother_pre, "Ugandshilling") | 	strpos(currother_pre, "Ugs") | 	strpos(currother_pre, "Ugshs") | 	strpos(currother_pre, "Ushs") | 	strpos(currother_pre, "Uss") | 	strpos(currother_pre, "Shilligs") 
replace curr = "SDP" if strpos(currother_pre, "Sudanese Ginia") |	strpos(currother_pre, "Sudanese Pounds") |	strpos(currother_pre, "Sudanese ginia") |	strpos(currother_pre, "Sudanese pound") |	strpos(currother_pre, "Sudanses ginia") |	strpos(currother_pre, "Sudsnese ginia") |		strpos(currother_pre, "Sudanses ginia") |	strpos(currother_pre, "Sudsnese ginia")																	
replace curr = "KES" if strpos(currother_pre, "Kenya")
replace curr = "CDF" if strpos(currother_pre, "zairi") | strpos(currother_pre, "DRC")
replace curr = "EGP" if strpos(currother_pre, "Egyptian Crancy 150")
replace curr = "SSP" if curr_pre == 1
replace curr = "USD" if curr_pre == 2
*Encode currency string variable
encode curr, gen(curr2)
drop curr currother_pre curr_pre
rename curr2 curr_pre
*Value labels
label define lCurr 1 "CDF" 2 "EGP" 3 "Gift" 4 "KES" 5 "SDG" 6 "SDD" 7 "SSP" 8 "UGX" 9 "USD", replace
label values curr_pre lCurr
label var curr_pre "In what currency was the item bought?"
*Generate currency identifiers
gen curr = ""
*For currother_post variable
replace curr = "SDD" if strpos(currother_post, "Sudanese dinar") 
replace curr = "UGX" if strpos(currother_post, "60 Ugsnda shls") | strpos(currother_post, "50000shillings") | strpos(currother_post, "250UGS") | strpos(currother_post, "Ugand") | strpos(currother_post, "Ugs") | strpos(currother_post, "UGS") | strpos(currother_post, "U,G,S") | strpos(currother_post, "Ushs") | strpos(currother_post, "Uss") | strpos(currother_post, "Ug sihillings") | strpos(currother_post, "Shill") | strpos(currother_post, "shill") | strpos(currother_post, "Ugand") | strpos(currother_post, "Ugs") | strpos(currother_post, "UGS") | strpos(currother_post, "U,G,S") | strpos(currother_post, "Ushs") | strpos(currother_post, "Uss") | strpos(currother_post, "Ug sihillings") | strpos(currother_post, "Shill") | strpos(currother_post, "shill") | strpos(currother_post, "60 Ugsnda shls") | strpos(currother_post, "50000shillings") | strpos(currother_post, "250UGS")
replace curr = "Gift" if strpos(currother_post, "Free") | strpos(currother_post, "Aid") | strpos(currother_post, "givety") | strpos(currother_post, "Givety") | strpos(currother_post, "Givety")  | strpos(currother_post, "Free") | strpos(currother_post, "give") | strpos(currother_post, "NGO") | strpos(currother_post, "ngo") | strpos(currother_post, "That was agivety") | strpos(currother_post, "givety") | strpos(currother_post, "Givety") | strpos(currother_post, "Givety") | strpos(currother_post, "dinar") | strpos(currother_post, "Free") | strpos(currother_post, "give") | strpos(currother_post, "NGO") | strpos(currother_post, "ngo") 
replace curr = "UGX" if strpos(currother_post, "Shillings") | strpos(currother_post, "Ugand shilling") | strpos(currother_post, "Ushs")
replace curr = "SDG" if strpos(currother_post, "Sudanese") | strpos(currother_post, "SDG") | strpos(currother_post, "sudunese") 
replace curr = "SDD" if strpos(currother_post, "Dinar") | strpos(currother_post, "dinar") | strpos(currother_post, "ginia") | strpos(currother_post, "Dinnar")
replace curr = "SSP" if curr_post == 1
replace curr = "USD" if curr_post == 2
*Encode currency string variable
encode curr, gen(curr2) label(lCurr)
drop curr currother_post curr_post
rename curr2 curr_post
label var curr_post "In what currency did you report the current value?"
*Reorder
order hh index own_post owntotal_post own_pre owntotal_pre yearp price_pre curr_pre price_post curr_post
*Add variables for currency conversion from price_post to USD
save "${gsdTemp}/assets.dta", replace
insheet using "${gsdData}/1-CleanInput/Other\section_h_currencies_post.csv", clear	
*Value labels
label define lCurr 1 "CDF" 2 "EGP" 3 "Gift" 4 "KES" 5 "SDG" 6 "SDD" 7 "SSP" 8 "UGX" 9 "USD", replace
label values curr_pre lCurr
save "${gsdTemp}/section_h_currencies_post.dta", replace
use "${gsdTemp}/assets.dta"
merge m:1 curr_pre yearp using "${gsdTemp}/section_h_currencies_post.dta",  keepusing(conv2usd conv2ssp) nogen
save "${gsdTemp}/assets-2.dta", replace
drop if hh==.
replace conv2usd = 1 if curr_pre==9

********************************************************************************
*Identify and replace outliers, using constraints in SSP
********************************************************************************
*Tabulate prior and current holdings to get overview
tabstat owntotal_pre owntotal_post, by(index) stat(p90 p95 p99 max) 
*Tabulate prior and current holdings
tab owntotal_post if owntotal_post >= 20
*Tabulate current holdings for mobile phones
tab owntotal_post if index == 12 & owntotal_post >= 20
*Tabulate current holdings for assets other than mobile phones
tab owntotal_post if index != 12 & owntotal_post >= 20
*Tabulate prior holdings
tab owntotal_pre if owntotal_pre >= 20
*Tabulate prior holdings for mobile phones
tab owntotal_pre if index == 12 & owntotal_pre >= 20
*Tabulate prior holdings for assets other than mobile phones
tab owntotal_pre if index != 12 & owntotal_pre >= 20
*Tag missing prices for purchased items 
gen price_missing_pre = .
replace price_missing_pre = 0 if own_pre==1 & price_pre!=.
replace price_missing_pre = 1 if own_pre==1 & price_pre==.
gen price_missing_post = .
replace price_missing_post = 0 if own_post==1 & price_post!=.
replace price_missing_post = 1 if own_post==1 & price_post==. 
*Check for completeness of data
tab price_missing_pre
tab price_missing_post
tabstat own_pre price_pre price_post, stat(n) by(own_pre)
tabstat own_post price_pre price_post, stat(n) by(own_post)
*Tabulate prices
tabstat price_pre , by(index) stat(n min q p90 p95 p99 max) 
tabstat price_post, by(index) stat(n min q p90 p95 p99 max) 
*Tag quantity and price outliers
foreach t in pre post {
	*Generate outlier indicator
	gen outlier_`t' = .
	replace outlier_`t' = 0 if owntotal_`t' < 100 & owntotal_`t' != .
	replace outlier_`t' = 1 if owntotal_`t' >= 100 & owntotal_`t' != .
	* Generate outlier indicator for prices, using constraints
	gen outlier_price_`t' = .
	replace outlier_price_`t' = 0 if price_`t' <= c_max_h & price_`t' != .
	replace outlier_price_`t' = 1 if price_`t' > c_max_h & price_`t' != .
	*Generate median quantities
	bysort index: egen owntotal_`t'_med = median(owntotal_`t')
	bysort index: egen owntotal_`t'_meda = max(owntotal_`t'_med)
	*Generate median prices
	bysort index yearp: egen price_`t'_medyr = median(price_`t') if curr_`t' == 7 & own_`t'==1
	bysort index yearp: egen price_`t'_medyra = max(price_`t'_medyr)
	bysort index yearp: egen price_`t'_medyra_count = count(price_`t')
	bysort index state: egen price_`t'_median_st = median(price_`t') if curr_`t' == 7 & own_`t'==1
	bysort index yearp: egen price_`t'_med_st = max(price_`t'_median_st)
	bysort index state: egen price_`t'_med_st_count = count(price_`t')
	bysort index : egen price_`t'_median = median(price_`t') if curr_`t' == 7 & own_`t'==1
	bysort index : egen price_`t'_med = max(price_`t'_median)
	*Set outliers to median
	replace owntotal_`t' = owntotal_`t'_med if outlier_`t' == 1
	gen price_`t'_cl = price_`t'
	qui replace price_`t'_cl = price_`t'_med if price_`t'_cl==. | outlier_price_`t' == 1
	qui replace price_`t'_cl = price_`t'_med_st if (outlier_price_`t' == 1 | price_missing_`t' ==1) & price_`t'_med_st!=. & price_`t'_med_st_count>=5
	qui replace price_`t'_cl = price_`t'_medyra if (outlier_price_`t' == 1 | price_missing_`t' ==1) & price_`t'_medyra!=. & price_`t'_medyra_count>=3
}
	
* Replace old prices with new cleaned prices
drop price_pre price_post
rename price_pre_cl price_pre 
rename price_post_cl price_post
drop  outlier* *missing* c_m* 
*Check effect of cleaning
tabstat price_pre , by(index) stat(N min q max)
tabstat price_post , by(index) stat(N min q max)

********************************************************************************
*Convert currencies CDF, EGP, UGX, and KES to USD, then to SSP
********************************************************************************
*Convert currencies to USD using year-specific exchange rate
gen price_pre_usd = . 
replace price_pre_usd = price_pre/conv2usd if curr_pre == 1 | curr_pre == 2 | curr_pre == 4 | curr_pre ==  8 
*Convert currencies from USD to SSP using year-specific exchange rate
gen price_pre_ssp = price_pre_usd*conv2ssp if curr_pre == 1 | curr_pre == 2 | curr_pre == 4 | curr_pre ==  8 
*Add newly converted prices
replace price_pre = price_pre_ssp if price_pre_ssp!=.
drop price_pre_ssp price_pre_usd
* Clean currencies: Where same price was paid pre and post, use same currency
replace curr_post = curr_pre if price_pre==price_post & price_pre!=.
replace curr_pre = curr_pre if price_pre==price_post & price_pre!=.
*Drop redundant variables 
drop *med*
save "${gsdTemp}/assets-3.dta", replace
use "${gsdTemp}/assets-3.dta", clear

********************************************************************************
*Calculate consumption flows 
********************************************************************************
*Calculating vintages. Note that as soon items are purchased, it is considered 
*one year old due to loss in value. I.e. items bought in 2015 are one year old.
tab yearp
gen double vintage=. 
replace vintage =(2015-yearp)+1
*Calculate vintage medians and replace where missing
bysort index : egen vintage_count=count(vintage) 
bysort index : egen vintage_median=median(vintage)
*Set missing vintages to medians
replace vintage=vintage_median if vintage==. & (own_pre==1 | own_post==1) 
*Label variables
lab var yearp "Year of purchase"
lab var vintage "Years since it was purchased"
drop vintage_count  vintage_median 

********************************************************************************
*Check data for consistency
********************************************************************************
*Tabulate prices
tabstat price_pre, by(index) stat(n min q p90 p95 p99 max) 
tabstat price_post, by(index) stat(n min q p90 p95 p99 max) 
tabstat own_pre, by(index) stat(mean)
tabstat own_post, by(index) stat(mean)
*Check data for completeness		
tabstat own_pre price_pre  yearp vintage curr_pre curr_post, stat(n) by(own_pre)
tabstat own_post price_post yearp vintage curr_pre curr_post, stat(n) by(own_post)

********************************************************************************
*Calculate depreciation rate 
********************************************************************************
*Assume constant asset-specific inflation rate of pi=0.5%
local pi = 0.005
*Estimate formula from Deaton and Zaidi (2002)
gen double drate= 1 - (1/(1+`pi'))*(price_post/price_pre)^(1/vintage)

********************************************************************************
* Check and clean depreciation rate
********************************************************************************
*Convert drate to missing if 
* 1) calculated drate is negative:
replace drate=. if drate<0
* 2) calculated drate is in top of dist despite small vintages; or 
* 3) calculated drate is in bottom of dist despite large vintages:
cumul drate if drate<., gen (drate_distribution) equal
label define ldum_distr 0 "Bottom 10% (0)"  1 "Top 10% (1)"
gen dum_distr=1 if drate_distribution>=.9 & drate_distribution<.
replace dum_distr=0 if drate_distribution<=.1 
label var dum_distr "Dummy indicating top/bottom of distribution"
label values dum_distr ldum_distr
* Replace inconsistent cases in the top of the drate distribution
replace drate=. if dum_distr==1 & vintage==1
* Replace inconsistent cases in the bottom of the drate distribution
replace drate=. if dum_distr==0 & vintage>=3
drop drate_distribution dum_distr
*Now calculate median depreciation rates by item where >= 3 observations avail.
bysort index: egen drate_count=count(drate) 
bysort index: egen drate_median=median(drate) if drate_count>=3
*Set missing drates to median drates calculated above, check them
replace drate = drate_median if drate==. 
tabstat drate, stat(n min q max) by(index)
*Label variables
lab var drate "Depreciation rate for each durable item by household"
lab var drate_median "Median depreciation rate for each durable item"
* Summarise the median depreciation rates in a table 
table index, c(median drate_median ) format (%10.2f)

********************************************************************************
*Calculate consumption flow 
********************************************************************************
*We assume a real interest rate of 5%, based on nominal interest rate of i=5.5%
*and above asset-specific inflation rate of 0.5%
local r = 0.05
*Calculate user cost (consumption flows) per item & vintage
*Changed by upape:
gen double cons_flow = (price_post/(1-drate_median+`pi'))*(`r' + drate_median) 
label var cons_flow "Consumption flow"
table index, c(median drate_median mean cons_flow) format (%10.2f)
*Calculate median consumption flow per item & vintage
bysort index vintage: egen cf_median = median(cons_flow)
lab var cf_median "Median consumption flow"
*Now we estimate the final consumption flow of durable goods, taking into account
*ownership of more than one item
gen cons_d= (price_post/(1-drate_median+`pi'))*(`r' + drate_median) if owntotal_post==1 & own_post==1
replace cons_d= (price_post/(1-drate_median+`pi'))*(`r' + drate_median) + ((owntotal_post-1)*cf_median) if owntotal_post>=2 & own_post==1

********************************************************************************
*Check for consistency
********************************************************************************
*Check consumption flow data
tabstat cons_d, by(index) stat(n min q p90 p95 p99 max)
* Check for completeness and consistency
tabstat drate_median drate cons_flow cons_d, stat(n) by(own_pre)
tabstat cons_d, stat(min q p90 p95 p99 max)
tabstat own_post  vintage cons_d , stat(n) by(own_post)
*Drop unnecessary variables
drop drate_count cons_flow cf_median  conv2usd conssum 

********************************************************************************
*Calculate weekly and daily cons flow 
********************************************************************************
*Convert from annual to weekly
gen cons_d_weekly=cons_d/365.25*7
gen cons_d_daily=cons_d/365.25
*Calculate per capita consumption flow
merge m:1 state ea hh using "${gsdData}/1-CleanTemp/hh_hhm.dta", keepusing(hhsize) assert(match master) keep(match master) nogen
gen cons_d_daily_pc=cons_d_daily/hhsize
*Label
label var cons_d_weekly "Consumption flow of durables (weekly) SSP"
label var cons_d "Consumption flow of durables (annual) SSP"
label var curr_pre "Currency in which item was originally purchased"
label var curr_post "Currency in which item's current value is reported"
label var own_pre "Did anyone in your household own a $(ra_namels} before the conflict?"
label var price_pre "Does the HH resp know what was the price for this newest \${ra_namels}?"
label var price_post "Does the HH resp know how much money he/she would get if he/she sold the newest \${ra_namels} today?"
label var ea "EA (anonimized)"
label var hh "Household ID (anonymized)"
label var conv2ssp "Currency conversion factor to SSP"
label var cons_d_daily "Consumption flow of durables (daily) SSP" 
label var cons_d_daily_pc "Consumption flow of durables (daily) per capita SSP" 
*Reorder 
order state ea weight hh hhsize index own_pre owntotal_pre yearp vintage price_pre curr_pre conv2ssp own_post owntotal_post price_post curr_post drate drate_median cons_d cons_d_weekly
sort  state ea hh 
*Remove records for households where food core cons was == 0 or . 
merge m:1 state ea hh using  "${gsdData}/1-CleanTemp/hh_food.dta", keepusing(food_opt0_hh_wk) assert(match master) keep(match master) nogen
drop if (food_opt0_hh_wk == 0 | food_opt0_hh_wk == .)
drop food_opt0_hh_wk 
drop if cons_d==.
save "${gsdData}/1-CleanOutput/assets.dta", replace
outsheet using "${gsdData}/1-CleanOutput/External\assets.csv", comma replace
saveold "${gsdData}/1-CleanOutput/External\assets_v12.dta", replace
*and calculate aggregates
collapse (sum) assets_hh_wk = cons_d_weekly, by(state ea hh)
label var assets_hh_wk  "Household weekly consumption flow of durable items"
save "${gsdData}/1-CleanTemp/hh_assets.dta", replace
